﻿namespace NLib.Web.Mvc.Ui.Tests.Models
{
    using System.ComponentModel.DataAnnotations;
    using System.Web.Mvc;

    using NLib.ComponentModel.DataAnnotations;

    public class ChangePasswordModel
    {
        [Required]
        [DataType(DataType.Password)]
        [Display(Name = "Current password")]
        public string OldPassword { get; set; }

        [Required]
        [StringLength(100, ErrorMessage = "The {0} must be at least {2} characters long.", MinimumLength = 6)]
        [DataType(DataType.Password)]
        [Display(Name = "New password")]
        public string NewPassword { get; set; }

        [DataType(DataType.Password)]
        [Display(Name = "Confirm new password")]
        //[Compare("NewPassword", ErrorMessage = "The new password and confirmation password do not match.")]
        [EqualsTo("NewPassword")]
        public string ConfirmPassword { get; set; }

        [GreaterThan("P2")]
        public int P1 { get; set; }
        public int P2 { get; set; }

        [GreaterThanOrEqualsTo("P4")]
        public int P3 { get; set; }
        public int P4 { get; set; }

        [LessThan("P6")]
        public int P5 { get; set; }
        public int P6 { get; set; }

        [LessThanOrEqualsTo("P8")]
        public int P7 { get; set; }
        public int P8 { get; set; }

        [NotEqualsTo("P10")]
        public int P9 { get; set; }
        public int P10 { get; set; }
    }

    public class LogOnModel
    {
        [Required]
        [Display(Name = "User name")]
        public string UserName { get; set; }

        [Required]
        [DataType(DataType.Password)]
        [Display(Name = "Password")]
        public string Password { get; set; }

        [Display(Name = "Remember me?")]
        public bool RememberMe { get; set; }
    }

    public class RegisterModel
    {
        [Required]
        [Display(Name = "User name")]
        public string UserName { get; set; }

        [Required]
        [DataType(DataType.EmailAddress)]
        [Display(Name = "Email address")]
        public string Email { get; set; }

        [Required]
        [StringLength(100, ErrorMessage = "The {0} must be at least {2} characters long.", MinimumLength = 6)]
        [DataType(DataType.Password)]
        [Display(Name = "Password")]
        public string Password { get; set; }

        [DataType(DataType.Password)]
        [Display(Name = "Confirm password")]
        [System.ComponentModel.DataAnnotations.Compare("Password", ErrorMessage = "The password and confirmation password do not match.")]
        public string ConfirmPassword { get; set; }
    }
}
